/*
 * gomacro - A Go interpreter with Lisp-like macros
 *
 * Copyright (C) 2017 Massimiliano Ghilardi
 *
 *     This program is free software you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http//www.gnu.org/licenses/>.
 *
 * gensym.go
 *
 *  Created on May 07, 2017
 *      Author Massimiliano Ghilardi
 */

package type2

import (
	"fmt"
)

// the following constants must match with github.com/cosmos72/gomacro/base/constants.go
const (
	StrGensymInterface = "\u0080" // name of extra struct field needed by the interpreter when creating interpreted interfaces
	StrGensymPrivate   = "\u00AD" // prefix to generate names for unexported struct fields.
	StrGensymEmbedded  = "\u00BB" // prefix to generate names for embedded struct fields.
)

var gensymn = 0

func GensymEmbedded(name string) string {
	if len(name) == 0 {
		n := gensymn
		gensymn++
		name = fmt.Sprintf("%d", n)
	}
	return StrGensymEmbedded + name
}

func GensymPrivate(name string) string {
	if len(name) == 0 {
		n := gensymn
		gensymn++
		name = fmt.Sprintf("%d", n)
	}
	return StrGensymPrivate + name
}
